xquery version "3.1";

(: This library module contains XQSuite tests for the utils module stored in
 : utils.xqm :)

module namespace utils-test = "http://bdn-edition.de/ns/utils-test";

import module namespace bdn-utils="http://bdn-edition.de/ns/utils" at "utils.xqm";

declare namespace tei="http://www.tei-c.org/ns/1.0";
declare namespace test="http://exist-db.org/xquery/xqsuite";


declare
    %test:args("_noesselt_1_1_2")
    %test:assertEquals("")
    %test:args("noesselt_1_1_2")
    %test:assertEquals("noesselt")
    function utils-test:get-author($node as text()) {
        bdn-utils:get-author($node)
};

declare
    %test:args("noesselt_1_1_2")
    %test:assertEquals("true")
    %test:args("griesbach_1_1_2")
    %test:assertEquals("false")
    %test:args("someone")
    %test:assertEquals("false")
    function utils-test:has-published-author($node as text()) {
        bdn-utils:has-published-author($node)
};

declare
    %test:args("noesselt_1_1_2")
    %test:assertEquals("true")
    %test:args("griesbach_1_1_2")
    %test:assertEquals("false")
    %test:args("someone")
    %test:assertEquals("false")
    function utils-test:has-published-author($node as text()) {
        bdn-utils:has-published-author($node)
};

declare
    %test:name("normal page")
        %test:args(
        "<html xmlns=""http://www.w3.org/1999/xhtml"">
            <head>
                <title></title>
            </head>
            <body>
            </body>
        </html>",
        "map{}")
    %test:assertEquals("neologie.css")
    %test:args(
        "<html xmlns=""http://www.w3.org/1999/xhtml"">
            <head>
                <title></title>
            </head>
            <body>
            </body>
        </html>",
        "map
          {
            ""file"": ""2501b.2.xml"",
            ""start-chapter"": 1,
            ""end-chapter"": 9999,
            ""edition"": ""digital"",
            ""modeledition"": ""true""
          }")
    %test:assertEquals("modeledition.css")
    function utils-test:css-injection($node as element(*), $model as map(*)) {
        bdn-utils:css-injection($node, $model)
};

declare
    %test:args("2w8bt")
    %test:assertEquals("griesbach")
    function utils-test:get-author($node as text()) {
        bdn-utils:get-autor-from-whitelist($node)
};
