xquery version "3.1";

module namespace kmgnav-utils="http://bdn-edition.de/ns/kmgnav-utils";
declare namespace bdn="http://www.bdn-edition.de/ns/1.0";
declare namespace tei="http://www.tei-c.org/ns/1.0";
(:declare namespace templates="http://exist-db.org/xquery/templates";:)
declare namespace tgmd="http://textgrid.info/namespaces/metadata/core/2010";
declare namespace xhtml="http://www.w3.org/1999/xhtml";


import module namespace templates="http://exist-db.org/xquery/templates";
import module namespace config="https://sade.textgrid.de/ns/config" at "../config.xqm";

import module namespace console="http://exist-db.org/xquery/console";

(: 
 Main template function for creating the second grey edition specific navigation bar
:)
declare function kmgnav-utils:nav-injection($node as node(), $model as map(*))
as element(nav)
{
  <nav id="edition-menu" class="nav navbar navbar-default">
      {kmgnav-utils:make-xs-sm-navbar($model)}
    <div id="edition-menu-content">
      <div class="d-flex flex-row full-width justify-content-sm-start justify-content-md-between justify-content-lg-between justify-content-xl-between">
        <!-- current edition -->
        <div class="title-display" aria-labelledby="titleDisplay">
          {templates:process(<span data-template="kmgnav-utils:get-title" />, $model)}
        </div>
        
        <!-- general utilities -->
        <div class="d-none d-lh-block d-cl-none d-md-block btn-group">
          <ul class="icon-list no-padding" id="edition-menu-util">
            <li class="icon-list">
              <a class="icon-list ripple ul teal-ul-on-gray js-edition-menu__info" href="#" title="Informationen" data-toggle="tooltip" data-placement="bottom">
                <div class="d-flex align-items-center justify-content-center icon-fix-size">
                  <i class="fa fa-lg fa-info-circle"/>
                </div>
              </a>
            </li>
            <li class="icon-list">
              <a class="icon-list ripple ul teal-ul-on-gray js-edition-menu__download" href="#" download="" title="XML-Download" data-toggle="tooltip" data-placement="bottom">
                <div class="d-flex align-items-center justify-content-center icon-fix-size">
                  <i class="fa fa-lg fa-download"/>
                </div>
              </a>
            </li>
          </ul>
        </div>
        
        <!-- edition settings -->
        <div class="d-none d-lh-block d-cl-none d-md-block">
          <ul class="icon-list no-padding" id="edition-menu-edition">
            <li class="icon-list btn-group">
              <a class="icon-list dropdown-toggle ul teal-ul-on-gray" href="#" role="button" data-toggle="dropdown" aria-expanded="false">
                <div class="d-flex align-items-center justify-content-center icon-fix-size">
                  <i class="fa fa-lg fa-eye"/>
                </div>
              </a>
              <div class="dropdown-menu dropdown-menu-right edition-menu-dropdown" aria-labelledby="dropdownMenuLink">
                {templates:process(<span data-template="kmgnav-utils:make-views-content" />, $model)}
              </div>
            </li>
            <li class="icon-list btn-group">
              <a class="icon-list dropdown-toggle ul teal-ul-on-gray" href="#" role="button" data-toggle="dropdown" aria-expanded="false">
                <div class="d-flex align-items-center justify-content-center icon-fix-size">
                  <i class="fas fa-lg fa-list-alt"/>
                </div>
              </a>
              <div class="dropdown-menu edition-menu-dropdown" aria-labelledby="dropdownMenuLink">
                {templates:process(<span data-template="kmgnav-utils:make-work-overview" />, $model)}
              </div>
            </li>
          </ul>
        </div>

        <!-- view settings and accessibility -->
        <div class="d-none d-lh-block d-cl-none d-md-block">
          <ul class="icon-list no-padding" id="edition-menu-edition">
            <li class="icon-list">
              <a id="zoom-out" class="icon-list ripple ul teal-ul-on-gray" href="#" role="button" data-toggle="tooltip" data-placement="bottom" data-original-title="Schriftgröße verringern">
                <div class="d-flex align-items-center justify-content-center icon-fix-size">
                  <i class="fa fa-lg fa-search-minus"/>
                </div>
              </a>
            </li>
            <li class="icon-list">
              <a id="zoom-in" class="icon-list ripple ul teal-ul-on-gray" href="#" role="button" data-toggle="tooltip" data-placement="bottom" data-original-title="Schriftgröße vergrößern">
                <div class="d-flex align-items-center justify-content-center icon-fix-size">
                  <i class="fa fa-lg fa-search-plus"/>
                </div>
              </a>
            </li>
            <li class="icon-list">
              <a id="icon-fullscreen" class="icon-list ripple ul teal-ul-on-gray" href="#" role="button" data-toggle="tooltip" data-placement="bottom" data-original-title="Vollbildansicht">
                <div class="d-flex align-items-center justify-content-center icon-fix-size">
                  <i class="fa fa-lg fa-expand"/>
                </div>
              </a>
            </li>
          </ul>
        </div>

      </div>
    </div>
  </nav>
};

(:~
 : Creates the edition specific menu for mobile application, 
 : e.g. if the screen is too small the menu changes to a three
 : lined fold out menu
 :
 : @author Hannes Riebl
 : @author Michelle Weidling
 : @author Johannes Biermann
Creates 
:)
declare function kmgnav-utils:make-xs-sm-navbar($model as map(*))
as element(div)
{
   <div class="container-fluid visible-xs visible-sm">
    <!-- Brand and toggle get grouped for better mobile display -->
    <div class="navbar-header">
      <a class="navbar-toggle collapsed" data-toggle="collapse"
      data-target="#navbar-edition-burger" aria-expanded="false">
        <span class="sr-only">Toggle navigation</span>
        <i class="fas fa-bars"/>
      </a>
        <span class="visible-xs visible-sm navbar-edition-label navbar-brand">
            {templates:process(<span data-template="kmgnav-utils:get-short-title" />, $model)}

        </span>
    </div>

    <!-- Collect the nav links, forms, and other content for toggling -->
    <div class="collapse navbar-collapse" id="navbar-edition-burger">
      <ul class="nav navbar-nav">
      
        <li class="dropdown">
          <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-haspopup="true" aria-expanded="false">
            <span class="white-ul-on-teal">Ansichten</span>
          </a>
          <ul id="navbar-edition-burger-views" class="dropdown-menu">
            {templates:process(<span data-template="kmgnav-utils:make-views-content" />, $model)}
          </ul>
        </li>
        
        <!-- 
        <li class="dropdown">
          <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button"
          aria-haspopup="true" aria-expanded="false">Kapitalnavigation <span class="caret"></span></a>
          <ul id="navbar-edition-burger-keys" class="dropdown-menu">
            {templates:process(<span data-template="kmgnav-utils:make-work-overview" />, $model)}
          </ul>
        </li>
        -->
        <!--
        <li class="dropdown">
          <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button"
          aria-haspopup="true" aria-expanded="false">Legende <span class="caret"></span></a>
          <ul id="navbar-edition-burger-keys" class="dropdown-menu">
            {templates:process(<span data-template="kmgnav-utils:make-legend-dropdown" />, $model)}
          </ul>
        </li>        
        -->

      </ul>
    </div>
  </div>
};

(:~
 : Creates the content for the views panel of the text
 : (e.g. diplomatic view, synoptic view)
 :
 : @author Hannes Riebl
 : @author Michelle Weidling
 : @author Johannes Biermann
 : @version 1.0
 : @param $model The model of the current page
 : @return element(span) Containing the body content
 :)
declare function kmgnav-utils:make-views-content($node as node()*, $model as map(*))
as element(div)*
{
    let $filename := request:get-parameter("file","")
    let $file := doc($config:sade-data || $filename || ".xml")
    let $edts-tmp := string-join($file//tei:witness/@xml:id, " ")
    let $editions := distinct-values(tokenize($edts-tmp, "[#\s]+"))
    (: makes iterating easier :)
    let $desc := string-join($file/tei:TEI/tei:teiHeader/tei:fileDesc/tei:sourceDesc/tei:listWit/tei:witness/tei:desc, "#")
    let $baseText := $file//tei:witness[1]/@xml:id/string()
    
    return
        element div { 
            attribute class { "views" },
            element a { 
                attribute class { 
                    "dropdown-item",
                    if (kmgnav-utils:isViewActive("digital")) then " current-edition" else ""
                },
                attribute href { kmgnav-utils:make-url($filename, "digital") },
                element span { 
                    attribute class { "white-ul-on-teal" },
                    "Interaktive textkritische Ansicht mit "|| $baseText ||" als Leittext"
                }
            },
            element div { 
                attribute class { "dropdown-divider" }
            },
            (for $edition at $countEdt in $editions
                for $date at $countDate in tokenize($desc, "#")
                where $edition != "" and $countEdt = $countDate
                return
                    element a { 
                        attribute class { 
                            "dropdown-item",
                            if (kmgnav-utils:isViewActive($edition)) then " current-edition" else ""
                        },
                        attribute href { 
                            kmgnav-utils:make-url($filename, $edition)
                        },
                        element span { 
                            attribute class { "white-ul-on-teal" },
                            string-join(("Textfassung", $edition, $date), " ")
                        }
                    }),
            element div { 
                attribute class { "dropdown-divider" }
            },
            element a { 
                attribute class { 
                    "dropdown-item",
                    if (kmgnav-utils:isViewActive("commentary")) then " current-edition" else ""
                },
                attribute href { kmgnav-utils:make-url($filename, "commentary") },
                element span { 
                    attribute class { "white-ul-on-teal" },
                    "Werkkommentar"
                }
            }
        }
};


(:~
 : Creates links to kmg.html with all necessary information,
 : i.e. file name and edition view.
 :
 : @author Hannes Riebl
 : @author Michelle Weidling
 : @author Johannes Biermann
 : @version 1.0
 : @param $filename The current file
 : @param $edition The current edition view
 : @param $foreword true() if we want to set a link to the editorial foreword
 : @return The link as xs:string
 :)
declare function kmgnav-utils:make-url($filename as xs:string, $edition as xs:string) as xs:string*
{
        let $url :=
            $config:app-root || "/kmg.html?"
            => substring-after("sade")
        return
            "kmg.html?&#38;file=" || $filename || "&#38;edition=" || $edition
};

(:~
 : Checks if the current view (request parameter edition) matches a certain view
 : can be used to highlight the current view in the navigation as active
 :
 : @author Johannes Biermann
 : @version 1.0
 : @param edition The edition/view to display
 : @return true false depending on if the edition matches the current request paramater
 :)
declare function kmgnav-utils:isViewActive($edition as xs:string) as xs:boolean 
{
    let $activeEdition := request:get-parameter("edition","a")
 
    let $isActive :=
         if (compare($activeEdition, $edition) = 0)
         then
            true()
         else
            false()
            
     return $isActive
};

(:~
 : Creates a span that displays the current author and his work's title. This
 : xhtml:span is placed in the edition's navigation bar.
 :
 :)
declare function kmgnav-utils:get-title($node as node(), $model as map(*))
as element(span)
{
    let $filename := request:get-parameter("file","")
    let $doc := doc($config:sade-data || $filename || ".xml")
    let $baseText := $doc//tei:witness[1]/@xml:id/string()
  
    let $activeEdition := request:get-parameter("edition","a")
    let $edition-display := 
        switch ($activeEdition)
          case "digital" return
            " [Interaktive textkritische Ansicht mit " || $baseText || " als Leittext]"
          case "commentary" return
            " [Werkkommentar]"
          default return
            " [Textfassung " ||$activeEdition || "]"  

    let $title-row-1 := $doc//tei:titleStmt//tei:title[@type = "main"]/string()
    let $title-row-2 := $doc//tei:titleStmt//tei:title[@type = "sub"]/string()

    return
        <span class="align-bottom">
            <span style="font-weight: bolder">{$title-row-1}</span>
            <span>{$edition-display}</span>
            <br />
            {$title-row-2}
        </span>
};


(:~ Returns a short bibliographic title needed for the collapsed navbar in the
 : edition views.  
 : @author Florian Barth
 : :)
declare function kmgnav-utils:get-short-title($node as node(), $model as map(*))
as element(span)
{
  let $filename := request:get-parameter("file", "")
  let $doc := doc($config:sade-data || "kmg/" || $filename || ".xml")
  
  let $activeEdition := request:get-parameter("edition","a")

    return
      let $title-row-1 := $doc//tei:titleStmt/tei:title[@type = "main"]/string()

      return
        <span>{$title-row-1} [Textfassung {$activeEdition}]</span>

};



(:~
 : Creates the legend drop down menu
 :
 : @author Hannes Riebl
 : @author Michelle Weidling
 : @author Johannes Biermann
 : @version 1.0
 : @param $model The model of the current page
 : @return element(div) Containing the body content
 :)
declare function kmgnav-utils:make-legend-dropdown($node as node()*, $model as map(*))
as element(div)*
{
  let $edition := request:get-parameter("edition","a")
  let $legend-entries := kmgnav-utils:legend-entries()

  return
    <div class="key-container">
      <div class="keySignNav">Textkritische Siglen <i class="fa fa-caret-up"></i></div>
      <span class="keySignContent">
        <table style="margin-left: 20px; margin-top: 5px; margin-bottom: 10px;">
          {$legend-entries("all")}
        </table>
      </span>
      <div class="keySymbolsNav">Symbole u. Ä. <i class="fa fa-caret-up"></i></div>
      <span class="keySymbolsContent">
        <table style="margin-left: 20px; margin-top: 5px; margin-bottom: 10px;">
        {
        if ($edition = 'digital')
          then (<tr><td>TODO</td></tr>)
        else (
             $legend-entries("single")    
        )
        }
        </table>
      </span>
    </div>
};

(:~
 : Creates the legend entries for the nav drop down
 :
 : @author Hannes Riebl
 : @author Michelle Weidling
 : @author Johannes Biermann
 : @version 1.0
 : @return map() Containing information about which sigla belong to which
 : edition view
 :)
declare function kmgnav-utils:legend-entries() as map(*)
{
  let $all :=
    <span>
        <tr>
            <td>|a165|</td>
            <td>Seitenwechsel in a</td>
        </tr>
        <tr>
            <td>[...]</td>
            <td>Editorische Einfügung</td>
        </tr>
        <tr>
            <td><span class="resp-tt">(lediglich)</span></td>
            <td>Einfügung von Klaus Mollenhauer</td>
        </tr>
        <tr>
            <td><span class="resp-tt italics">Oikos</span></td>
            <td>Hervorhebung durch Klaus Mollenhauer</td>
        </tr>
    </span>

  let $single-digital :=
    <span>
        <tr>
            <td><i class="fas fa-user" style="cursor:default" /></td>
            <td>Personendaten</td>
        </tr>
        <tr>
            <td><i class="fa fa-image" style="cursor:default" /></td>
            <td>Angaben zum Kunstwerk</td>
        </tr>
        <tr>
            <td><i class="fa fa-external-link-alt" style="cursor:default" /></td>
            <td>Externe Verlinkung</td>
        </tr>
        <tr>
            <td><i class="fa fa-music" style="cursor:default" /></td>
            <td>Angaben zum Musikstück</td>
        </tr>
        <tr>
            <td><i class="fa fa-newspaper" style="cursor:default" /></td>
            <td>Angaben zu einem Periodikum</td>
        </tr>
        <tr>
            <td><i class="fa fa-copyright" style="cursor:default" /></td>
            <td>Angaben zu einer Marke</td>
        </tr>
        <tr>
            <td><i class="fa fa-comment-alt" style="cursor:default" /></td>
            <td>Editorische Anmerkung</td>
        </tr>   
        <tr>
            <td><i class="fa fa-link" style="cursor:default" /></td>
            <td>Interne Verlinkung</td>
        </tr>
        <tr>
            <td><i class="fa fa-book" style="cursor:default" /></td>
            <td>Literaturnachweis</td>
        </tr>
        <tr>
            <td><i class="fa fa-book kmg" style="cursor:default; color: #999999; background-color: white;" /></td>
            <td>Literaturnachweis (editorische Ergänzung)</td>
        </tr>     
    </span>

  return
    map
    {
      "all": $all,
      "single": $single-digital
    }
};


(:~~~~~~~~~~~~~~~~~~~~~~~~
   Creates Overview of chapters
 : @author Florian Barth
 : :)

declare function kmgnav-utils:make-work-overview($node as node()*, $model as map(*))
as element(xhtml:a)*
{
    let $current-view := request:get-parameter("edition", "digital")
    let $filename := request:get-parameter("file", "")
    let $doc := doc($config:sade-data || "kmg/" || $filename || ".xml")
    let $headers := $doc//tei:head/tei:label[@type='head']/..
    
    (: for-loop via xquery-indices (1-3) to pass jquery-indices (0-2) as chapter-attribute :)
    for $i in 1 to count($headers)
    return
        element xhtml:a
            {
            attribute class {"dropdown-item ul"},
            attribute href {"#goto"},
            attribute id {$i - 1},
            element xhtml:span
                {
                    attribute class {"white-ul-on-teal"},
                    $headers[$i]/string()
                } 
            }

};
  